function rescue_dog(id, x, y, z)

  local map=get_map_ptr(z)
  toggle_switch(id,x,y,z)
  if map:get_feat_val(x+1,y-1)==0 then return end

  m=get_sent_ptr_xyz(x+1,y-2,z)
  if m==nil then return end

  m=get_monster_ptr(m.id)
  if m==nil then return end

  reset_trigger(x+1,y-1,z,-1)
  update_everyones_fov(m)
  if is_online() then return ; end

  set_pet(m, id, "Bathplug")
  local p=get_player_ptr(id)
  set_monster_level(m,p.lvl*1.3)

  update_everyones_fov(m)
  send_message(id,"The mutant dog appears to accept you as its master!")
  set_player_int_var(id, "has_bathplug", 1)
  map.spawners:del(m.x,m.y)
  map:save_features()
end

-- hack to make 'activate vending machine' work: only if vending machine sits on vault floor tile
function activate_tile_020 (id, tile, x, y, z)
  local m=get_sent_ptr_xyz(x,y,z)
  if m~=nil and m.name=="Vending Machine" then
    send_message(id, "Press b to buy from the vending machine!")
  else
    send_message(id, "Activate what?")
  end
end

function activate_tile_068 (id, tile, x, y, z) -- terminal - has the bigger screen
  send_message(id, "This terminal is not functional.")
end

function activate_tile_069 (id, tile, x, y, z) -- console
  send_message(id, "This console is not functional.")
end

function activate_tile_070 (id, tile, x, y, z) -- terminal - has the bigger screen
  console_helper(id,tile,x,y,z)
end

function activate_tile_071 (id, tile, x, y, z) -- console
  console_helper(id,tile,x,y,z)
end

function activate_tile_074 (id, tile, x, y, z) -- locker
  send_message(id, "Try searching the locker.")
end

function console_helper(id,tile,x,y,z)

  local r=int_rand(12)
  local p=get_player_ptr(id)
  if r==0 then

    make_peering(id)
    send_message(id, "Press space to exit.")

  elseif r==1 then

    local bits={"knob","lever","dial","button","bezel","meter"}
    send_message(id, "A important "..get_random_element(bits).." breaks and falls off and the terminal goes dead.")
    give_item(id,Item(0x147))

  elseif r==2 and int_rand(3)==1 then

    local m=spawn_near_id(0x20b,id)
    if m~=nil then
      set_monster_level(m, p.lvl+2)
      m:set_health(HN_TRANSPARENT, -1)
      send_message(id, "You summon a ghost from the machine!")
      if p:is_visible() then
        if(math.random(3)==1) then
          m:set_align(ALIGN_GOOD)
          m.owner_id=id
          send_message(id,"It seems relatively pleased to see you!");
        end
        m.time_alive=60
      end
      update_everyones_fov(m)
    else
      -- this is very unlikely - the spawn failed
      send_message(id,"Lights blink on and off wildy, then the machine dies.");
    end

  elseif r==3 then

    -- random skill gain
    local ska={0,3,6,8,0x10}
    local skn=get_random_element(ska)
    send_message(id, "You gain some interesting new insights into the skill of "..sc:get_skillname(skn).."!")
    bump_skill(id,skn,10)
    simple_send_event(id,EVENT_MAGIC,3)

  elseif r==4 then

    -- random stat gain
    local rr=int_rand(3)
    if rr==0 then
      p:bump_stats(10,0,0)
      send_message(id, "The old machine teaches you a thing or two about strengthening your physique!")
    elseif rr==1 then
      p:bump_stats(0,10,0)
      send_message(id, "The mainframe guides you gently through the process of improving your agility!")
    else
      p:bump_stats(0,0,10)
      send_message(id, "You feel smarter just being able to switch this old machine on!")
    end
    simple_send_event(id,EVENT_MAGIC,3)
    sync_stats(id)

  elseif r==5 then

    -- electrocution
    send_event(z,id,p.x,p.y,EVENT_MAGIC,spells:get_spell_id("zap"),x,y)
    local req_dmg=p.hp*(55+math.random(55))/120
    local resist=p:get_resistance(MT_LIGHTNING)
    if resist~=0 then req_dmg=(100-resist)*req_dmg/100 end -- lightning resist
    hurt(id, req_dmg, "a bad earth on a faulty old console")

  elseif r==6 then

    p:set_health(HN_ENRAGED,30)
    p.rage=100
    send_message(id,"Using the computer makes you really angry and drives you into fit of rage!");
    sync_all(id)

  elseif r==7 then

    send_message(id, "Using the computer gives you a great user experience!")
    give_xp(id, (p.xp/10)/server_config:get_int("xp_multiplier")+10, true)

  else
    -- nothing
    send_message(id, "Lights on the console flicker and fade.")

  end

  set_and_send_new_tile(x,y,z,tile-2)
end

function activate_421 (id, itm, bcode, x, y, z) -- light
  map_set_item_code(x, y, z, Item(0x422))
  update_fov(id)
end

function activate_422 (id, itm, bcode, x, y, z) -- light
  map_set_item_code(x, y, z, Item(0x421))
  update_fov(id)
end

