--

-- id is user id
-- tgt is target id - may be -1 for no valid target!
-- alt is 0 for normal use, 1 for forced use-dir (like feeding)
-- itm is full item code, bcode is itm & 0xfff
-- x y z is the location of where the item is pointed at

-- flashlight
function use_101 (id,tgt_id,alt,itm,bcode,x,y,z)

  local p=get_player_ptr(id)

  rad=5
  str="on"

  if p:get_torch()>0 then

    rad=0
    str="off"
    p:extinguish_torch()

  else

    p:set_torch(rad)

  end

  send_message(id, "Flashlight "..str)

  p:set_health(HN_HIDING,0);
  if(p:get_health(HN_INVISIBLE)>0) then p:set_health(HN_INVISIBLE,0); end

  sync_health(id)
end

-- POCKET WATCH
function use_146 (id,tgt_id,alt,itm,bcode,x,y,z)

  local p=get_player_ptr(id)
  if(p:get_health(HN_BLIND)~=0) then
    send_message(id,"You can't see the digits on your watch because you are blind!")
  else
    send_time(id,is_cursed(itm));
  end

end

-- SKULL KEY
-- ie keycard
function use_521 (id,tgt_id,alt,itm,bcode,x,y,z)

  local smap=get_map_ptr(z)
  local plyr=get_player_ptr(id)

  chest=smap:get_item_code(x,y)
  if(get_base_code(chest)==0x108 and (get_modifier(smap:get_item_code(x,y))&2)==2) then

    if(is_cursed(itm)) then

      send_message(id,"Keycard broke!");
    else

      smap:set_item_code(x,y,make_code(get_base_code(chest),get_material(chest),get_to_mod(chest),get_modifier(chest)-2));
      send_message(id,"Unlocked!")
      update_everyones_fov(plyr)
    end
    remove_item(id, itm)

  elseif(smap:get_feat_typ(x, y)==TRIG_LOCK) then

    if(is_cursed(itm)) then

      send_message(id,"Keycard broke!");
      remove_item(id, itm)

    elseif(smap:get_feat_val(x, y)==1) then

      send_message(id,"Unlocked!");
      reset_trigger(x,y,z);
      update_everyones_fov(plyr);
      remove_item(id, itm)

    else

      send_message(id,"It's already unlocked.");

    end

  elseif(smap:get_feat_typ(x, y)==TRIG_LOCK_NOPICK) then -- doesnt remove skull key

    if smap:get_feat_text(x,y)==plyr.account_name then -- house

      reset_trigger(x,y,z,-1);
      if smap:get_feat_val(x, y)==1 then
        send_message(id,"Locked!");
      else
        send_message(id,"Unlocked!");
      end
      update_everyones_fov(plyr);
    else
      send_message(id,"This lock can't be opened with this key.");
    end

  else

    send_message(id,"There's no lock here.");

  end

end

-- PROTECTION SCROLL
function use_511 (id,tgt_id,alt,itm,bcode,x,y,z)

  local plyr=get_player_ptr(id)
  set_health(id,HN_PROTECTION,1800)
  -- update_everyones_fov(plyr)
  send_message(id,"You feel somewhat protected!")
  if(not plyr:is_dm()) then remove_item(id, itm, 1); end

end

-- spareparts
function use_147 (id,tgt_id,alt,itm,bcode,x,y,z)

  local p=get_player_ptr(id)
  if sc:get_racename(p.race)=="droid" then

    -- cut paste from effect heal / yellow pot

    hp,hpmax,mana,manamax = get_hp_and_mana(id)

    healed=healer_helper(id,itm)

    if get_health(id,HN_WOUNDED)~=0 then healed=0 end
    if healed>0 then
      heal(id, healed)
      if(is_player(id)) then
        send_party_info(id)
        sync_stats(id)
      end
      update_fov(id) -- so bars are updated
      send_message(id, "Repaired "..healed.." HP!")
    else
      send_message(id, "No effect!")
    end

    if(not p:is_dm()) then remove_item(id, itm, 1); end

  else
    send_message(id,"You can only use these as a droid to heal yourself.")
    send_message(id,"If you are an engineer try using your toolbox to make something.")
    gs_scripted_item_no_turn_bump=true
  end
end

-- IED
function use_5f7 (id,tgt_id,alt,itm,bcode,x,y,z)

  send_message(id,"Drop this on the ground and any enemies that step on it will set it off!")
  gs_scripted_item_no_turn_bump=true
end

-- grenade
function use_14a (id,tgt_id,alt,itm,bcode,x,y,z)

  send_message(id,"Use your throw grenade ability, and don't forget to select a target first!")
  gs_scripted_item_no_turn_bump=true
end

-- cloaking device
function use_14b (id,tgt_id,alt,itm,bcode,x,y,z)

  local tgt=get_sent_ptr(tgt_id)
  -- tgt:extinguish_torch()

  set_health(tgt_id,HN_INVISIBLE,30)
  send_message(tgt_id,"You disappear from view!");
  if(tgt_id~=id) then
    send_message(id, "Target disappeared from view!");
  end
  update_everyones_fov(tgt)

  local plyr=get_player_ptr(id)
  if not plyr:is_dm() then remove_item(id, itm, 1); end
end

-- teleporter
function use_14c (id,tgt_id,alt,itm,bcode,x,y,z)

  local plyr=get_player_ptr(id)
  local smap=get_map_ptr(plyr.map_level)

  if(plyr:get_health(HN_JAILED)~=0 or smap:get_feat_typ(plyr.x,plyr.y)==FEATURE_JAIL) then
    send_message(id,"No effect!");
    return 0;
  end

  if(not plyr:is_dm()) then remove_item(id, itm, 1); end

  if(is_cursed(itm)) then
    rc=spell_blink_random("ip2",plyr,nil,true,x,y,"")
  else
    rc=spell_blink("ip",plyr,nil,true,x,y,"")
  end

end

--sentry gun
function use_14d (id,tgt_id,alt,itm,bcode,x,y,z)

  local plyr=get_player_ptr(id)
  local m=basic_summon(plyr,0x20a, 60)
  if m~=nil then
    set_monster_level(m, plyr.lvl+1)
    m.hp=10
    m:set_hp_max(10)
    m.talk_line="script_unsummon_sentry"
    if not plyr:is_dm() then remove_item(id, itm, 1); end
    update_everyones_fov(m)
  end
end
function script_unsummon_sentry(m,id)
  hurt(m.id,100000,"")
  if int_rand(100)<33 then
    send_message(id,"The sentry gun fell to pieces and all you get out of it is a single piece of scrap!")
    give_item(id, Item(0x147))
  else
    send_message(id,"The sentry gun packs up nicely and you stash it into your inventory.")
    give_item(id, Item(0x14d))
  end  
end
