function load_map_008(lvl, load_on_the_fly)

  if not ok_to_regen_random_lua_map(lvl) then return end
  local map=get_map_ptr(lvl)
  map:del_all_spawners()
  -- reset to all walls
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do

      t=87 -- default wall
      map:set_tile(x, y, t)
      map:del_feat(x, y)
      map:destroy_pile(x, y)

    end
  end
  map:mk_random(lvl, 0, 1, 5, RT_CAVE, "32,85", "", 0)
  map.is_random=false

  add_litter(map,32,{55},3)
  add_litter(map,32,{45},6)
  add_litter(map,32,{44,51,46,52,56,57,58,59,53},20)

  -- add your own spawners
  -- map monster lvl goes into 1,1
  map:add_feat(1,1,SIGN,9)
  map.spawners:add(2,10,0,lvl,math.random(5,10),0,2,2,0)
  map:add_feat(2,2,SPAWNER); -- for maped's benefit only  

  -- for every brazier, add spawner
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do

      itm=map:get_item_code(x,y)
      if itm==Item(0x10e) then
        add_cave_spawner(map,lvl,x,y)
      end
    end
  end

  map:save_map()
  map:save_features()
  map:save_items()
end

function add_cave_spawner(map,lvl,x,y)
  m=0x205
  n=1+int_rand(3)
  if spawner_nearby(map,x,y) then return; end
  map.spawners:add(0, m, 0, lvl, n, 0, x, y, 3, 0, "level_mob_wrapper")
  map:add_feat(x,y,SPAWNER); -- for maped's benefit only
end
