function load_map_010(lvl, load_on_the_fly)

  make_subway(lvl, load_on_the_fly, 9, 1, 13)
end

-- delete any items in the subway entrance map
function load_map_009(lvl, load_on_the_fly)

  local map=get_map_ptr(lvl)
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do
      map:destroy_pile(x, y)
    end
  end
  map:save_map()
  map:save_items()
end

function make_subway(lvl, load_on_the_fly, up, down, mob_level)

  -- uncomment so smap is randomised only on server load!
  if not ok_to_regen_random_lua_map(lvl) then return end

  local smap=get_map_ptr(lvl)
  smap:set_size(200,100,true) -- was 250x
  smap:del_all_spawners()

  -- reset to all walls
  for x=0,smap:get_max_x()-1 do
    for y=0,smap:get_max_y()-1 do

      smap:set_tile(x, y, 21)
      smap:del_feat(x, y)
      smap:destroy_pile(x, y)
    end
  end

  -- smap monster lvl goes into 1,1
  smap:add_feat(1,1,SIGN,mob_level)
  smap.spawners:add(2,mob_level,0,lvl,math.random(5,10),0,2,2,0)
  smap:add_feat(2,2,SPAWNER); -- for maped's benefit only

  -- r is basically wht dir we are going
  --
  r=int_rand(2)+2
  w=smap:get_max_x()
  h=smap:get_max_y()
  --w=70
  --h=70

  x=math.floor(w/2)
  y=math.floor(h/2)

  if r==0 then

    y=h-2
  elseif r==1 then

    y=1

  elseif r==2 then

    x=1

  elseif r==3 then

    x=w-2

  end

  step=1
  maindir=r

  centres={}

  lastx=0
  lasty=0
  firstx=0
  firsty=0
  repeat

    runlen=int_rand(10)+25
    if r~=maindir then runlen=int_rand(10)+5 end
    dx=0
    dy=0
    if r==0 then
      dy=-1
    elseif r==1 then
      dy=1
    elseif r==2 then
      dx=1
    elseif r==3 then
      dx=-1
    end

    -- writelog2("r="..r.." runlen="..runlen)

    for i=1,runlen do
      x=x+dx
      y=y+dy
      if offMap(smap,x,y) then break end
      subwayPlot(smap, step, x, y, r, lastdir)
      lastx=x
      lasty=y
      lastdir=r
      if firstx==0 then
        firstx=x
        firsty=y
        plot_fence(lvl,firstx,firsty,r)
      end
      if i==math.floor(runlen/2) then
        c={x,y}
        table.insert(centres,c)
      end
    end

    -- get new r

    if step%2==0 then
      r=maindir
    else
      repeat
        r=int_rand(4)
      until r~=lastdir and (lastdir==0 and r~=1 or lastdir==1 and r~=0 or lastdir==2 and r~=3 or lastdir==3 and r~=2)
    end
    step=step+1

  until offMap(smap,x,y)
  -- writelog2("end x="..x.." y="..y.." w="..w.." h="..h)
  plot_last_fence(lvl,lastx,lasty,lastdir)

  -- platform
  platform=math.floor(step/2)+1
  repeat
    platform=platform-1
  until smap:get_tile(centres[platform][1], centres[platform][2]-1)==22

  cx=centres[platform][1]
  cy=centres[platform][2]
  for x=cx-6,cx+7 do

    smap:set_tile(x,cy-4,39)
    smap:set_tile(x,cy-2,20)
    smap:set_tile(x,cy-3,20)
    smap:set_tile(x,cy+2,20)
    smap:set_tile(x,cy+3,20)
    smap:set_tile(x,cy+4,39)

    if (x-cx)%4==0 then
      smap:set_tile(x,cy+4,33)
      smap:set_tile(x,cy-4,33)
    end

  end
  for y=cy-4,cy+4 do
    t=smap:get_tile(cx-6,y)
    if t!=22 and t!=30 then smap:set_tile(cx-7,y,39); end
    t=smap:get_tile(cx+7,y)
    if t!=22 and t!=30 then smap:set_tile(cx+8,y,39); end
  end
  smap:set_tile(cx-2,cy-4,84)--fence
  smap:set_tile(cx-2,cy-5,48)--stairs
  smap:set_tile(cx-2,cy-6,39)--wallaroundstairs
  smap:set_tile(cx-3,cy-6,39)--wallaroundstairs
  smap:set_tile(cx-1,cy-6,39)--wallaroundstairs
  smap:set_tile(cx-1,cy-5,39)--wallaroundstairs
  smap:set_tile(cx-3,cy-5,39)--wallaroundstairs

  smap.spawners:add(0, 0x291, 0, lvl, 1, 0, cx-2, cy+3, -1, 0, "vending_machine_init")
  smap:add_feat(cx-2, cy+3,SPAWNER) -- for maped's benefit only

  smap.spawners:add(0, 0x291, 0, lvl, 1, 0, cx+3, cy+3, -1, 0, "vending_machine_init")
  smap:add_feat(cx+3, cy+3,SPAWNER) -- for maped's benefit only

  -- chairs
  for x=cx-6,cx+6 do
    if (x-cx)%5==0 then
      smap:set_tile(x,cy+3,34)
      smap:set_tile(x+1,cy+3,35)
      smap:set_tile(x,cy-3,34)
      smap:set_tile(x+1,cy-3,35)
    end
  end

  lights={{cx-6, cy-3},{cx-6, cy+3},{cx+7, cy-3},{cx+7, cy+3}}
  for i,l in ipairs(lights) do
    smap:add_item(l[1], l[2], 1, Item(0x421))
    --smap:set_as_furniture(l[1], l[2])
  end

  local m=CA_cave(smap:get_max_x(), smap:get_max_y(),42)

  for x = 0,smap:get_max_x()-1 do
    for y = 0,smap:get_max_y()-1 do

      t=m[x+1][y+1]
      if t=="." and smap:get_tile(x,y)==21 then smap:set_tile(x,y,32) end
    end
  end
  for x = 1,smap:get_max_x()-2 do
    for y = 1,smap:get_max_y()-2 do
      t=smap:get_tile(x,y)
      if t==21 and not_adj_to_track(lvl,x,y) then
        smap:set_tile(x,y,88)
      end
    end
  end

  l={44,51,46,52,55,56,57,58,59,43,45}
  add_litter(smap,32,l,10)

  l={39,40,41,42}
  add_litter_against_walls(smap,21,22,l,20,0,0)
  l={51,56,58,59}
  add_litter(smap,30,l,20)

  -- add lights and spawners
  for r,c in ipairs(centres) do
    smap:add_item(c[1], c[2], 1, Item(0x10e)) -- barrel
    smap:set_as_furniture(c[1], c[2])

    if r>1 then

      m=0x201
      n=9+int_rand(3)
      str=""
      if int_rand(4)==0 then
        m=0x204
        n=5+int_rand(3)
        str="2"
      end
      smap.spawners:add(0, m, 0, lvl, n, 0, c[1], c[2]+1, 10, 0, "level_mob_wrapper"..str)
      smap:add_feat(c[1],c[2]+1,SPAWNER); -- for maped's benefit only
    end
  end

  -- add cave spawners
  local cnt=0
  for x=10,smap:get_max_x()-11,10 do
    for y=10,smap:get_max_y()-11 do
      if cnt>0 then cnt=cnt-1 end
      if smap:get_tile(x,y)==32 and cnt==0 and not_near_centre(x,y,centres) then
        smap.spawners:add(0, 0x20d, 0, lvl, math.random(2,3), 0, x, y, 3, 0, "level_mob_wrapper"..str)
        smap:add_feat(x,y,SPAWNER); -- for maped's benefit only
        --cnt=math.random(10,30)
        cnt=10
      end
    end
  end

  -- ladders
  smap:destroy_pile(firstx, firsty)
  smap:set_tile(firstx,firsty,62)
  smap:add_feat(firstx, firsty, LV_CHANGE, up)

  smap:destroy_pile(lastx, lasty)
  smap:set_tile(lastx,lasty,62)
  smap:add_feat(lastx, lasty, LV_CHANGE, down)

  smap:save_map();
  smap:save_features();
  smap:save_items();

end

function subwayPlot(smap, step, x, y, dir, lastdir)

  t=30
  -- if step==1 then t=220 end
  smap:set_tile(x,y,t)

  if dir==0 or dir==1 then
    smap:set_tile(x-1,y,23)
    smap:set_tile(x+1,y,23)
  else
    smap:set_tile(x,y-1,22)
    smap:set_tile(x,y+1,22)
  end

  if step==1 then return end

  -- there gotta be an algorithm for these bends --;
  if dir==3 and lastdir==1 then
    smap:set_tile(x,y-1,27)
    smap:set_tile(x+1,y+1,22)
    smap:set_tile(x+2,y+1,27)
  end

  if dir==3 and lastdir==0 then
    smap:set_tile(x,y+1,25)
    smap:set_tile(x+1,y-1,22)
    smap:set_tile(x+2,y-1,25)
  end

  if dir==0 and lastdir==2 then
    smap:set_tile(x-1,y,27)
    smap:set_tile(x+1,y+1,23)
    smap:set_tile(x+1,y+2,27)
  end

  if dir==0 and lastdir==3 then
    smap:set_tile(x+1,y,26)
    smap:set_tile(x-1,y+1,23)
    smap:set_tile(x-1,y+2,26)
  end

  if dir==1 and lastdir==2 then
    smap:set_tile(x-1,y,25)
    smap:set_tile(x+1,y-1,23)
    smap:set_tile(x+1,y-2,25)
  end

  if dir==1 and lastdir==3 then
    smap:set_tile(x+1,y,24)
    smap:set_tile(x-1,y-1,23)
    smap:set_tile(x-1,y-2,24)
  end

  if dir==2 and lastdir==0 then
    smap:set_tile(x,y+1,24)
    smap:set_tile(x-1,y-1,22)
    smap:set_tile(x-2,y-1,24)
  end

  if dir==2 and lastdir==1 then
    smap:set_tile(x,y-1,26)
    smap:set_tile(x-1,y+1,22)
    smap:set_tile(x-2,y+1,26)
  end

end

function offMap(smap, x, y)

  w=smap:get_max_x()
  h=smap:get_max_y()
  return x<2 or x>=w-2 or y<2 or y>=h-2
end

function CA_cave (w,h,weight)

  weight=weight or 45
  local dir = {
    {-1,-1}, --nw
    {0,-1}, --n
    {1,-1}, --ne
    {-1,0}, --w
    {1,0}, --e
    {-1,1}, --sw
    {0,1}, --s
    {1,1} --se
  }
  local map = {}
  local cx=w/2
  local cy=h/2
  for x = 1, w do
    map[x] = {}
    for y = 1, h do
      if math.random(0,100) < weight+dist(x,y,cx,cy)/3 then
        map[x][y] = "#"
      else
        map[x][y] = "."
      end
    end
  end
  for i = 1, 4 do
    for x = 1, w do
      for y = 1,h do
        neighbors = 0
        for ii = 1,#dir do
          if map[x+dir[ii][1]] then
            if map[x+dir[ii][1]][y+dir[ii][2]] then
              if map[x+dir[ii][1]][y+dir[ii][2]] == "#" then
                neighbors = neighbors + 1
              end
            else
              neighbors = neighbors+1
            end
          else
            neighbors = neighbors+1
          end
        end
        if map[x][y] == "#" then
          if neighbors >= 3 then
            map[x][y] = "#"
          else
            map[x][y] = "."
          end
        elseif map[x][y] == "." then
          if neighbors >= 6 then
            map[x][y] = "#"
          else
            map[x][y] = "."
          end
        end
      end
    end
  end
  for x = 1, w do
    for y = 1, h do
      if x == 1 or x == w or y == 1 or y == h then
        map[x][y] = "#"
      end
    end
  end
  return map
end

function not_adj_to_track(lvl,x,y)

  local smap=get_map_ptr(lvl)
  nt=smap:get_tile(x,y-1)
  st=smap:get_tile(x,y+1)
  et=smap:get_tile(x+1,y)
  wt=smap:get_tile(x-1,y)
  ne=smap:get_tile(x+1,y-1)
  nw=smap:get_tile(x-1,y-1)
  se=smap:get_tile(x+1,y+1)
  sw=smap:get_tile(x-1,y+1)
  if nt>=22 and nt<=27 then return false; end
  if et>=22 and et<=27 then return false; end
  if st>=22 and st<=27 then return false; end
  if wt>=22 and wt<=27 then return false; end
  if ne>=22 and ne<=27 then return false; end
  if nw>=22 and nw<=27 then return false; end
  if sw>=22 and sw<=27 then return false; end
  if se>=22 and se<=27 then return false; end
  return true
end

function plot_fence(lvl,x,y,dir)

  local smap=get_map_ptr(lvl)
  if dir==2 then
    smap:set_tile(x-1,y-1,84)
    smap:set_tile(x-1,y,84)
    smap:set_tile(x-1,y+1,84)
    smap:set_tile(x-2,y-1,225)
    smap:set_tile(x-2,y,225)
    smap:set_tile(x-2,y+1,225)
  end
  if dir==3 then
    smap:set_tile(x+1,y-1,84)
    smap:set_tile(x+1,y,84)
    smap:set_tile(x+1,y+1,84)
    smap:set_tile(x+2,y-1,225)
    smap:set_tile(x+2,y,225)
    smap:set_tile(x+2,y+1,225)
  end
  if dir==0 then
    smap:set_tile(x-1,y+1,84)
    smap:set_tile(x,y+1,84)
    smap:set_tile(x+1,y+1,84)
    smap:set_tile(x-1,y+2,225)
    smap:set_tile(x,y+2,225)
    smap:set_tile(x+1,y+2,225)
  end
  if dir==1 then
    smap:set_tile(x-1,y-1,84)
    smap:set_tile(x,y-1,84)
    smap:set_tile(x+1,y-1,84)
    smap:set_tile(x-1,y-2,225)
    smap:set_tile(x,y-2,225)
    smap:set_tile(x+1,y-2,225)
  end
end

function plot_last_fence(lvl,x,y,dir)
  if dir==1 then dir=0
  elseif dir==0 then dir=1
  elseif dir==2 then dir=3
  elseif dir==3 then dir=2
  end
  plot_fence(lvl,x,y,dir)
end

function not_near_centre(x,y,centres)

  for r,c in ipairs(centres) do
    if distance(x,y,c[1],c[2])<10 then return false end
  end
  return true
end
