function load_map_002(lvl, load_on_the_fly)

  make_newstyle_dungeon(lvl,load_on_the_fly, 3,0, 2, 17, 28, 110, 178)
end

function load_map_003(lvl, load_on_the_fly)

  make_euo_style_dungeon(lvl, load_on_the_fly, 4, 2, 5, 10, 11, 12, 13)
end

function load_map_004(lvl, load_on_the_fly)

  make_vault(lvl, load_on_the_fly, 5, 3, 9, 10, 11, 12, 13)
end

function choose_and_make_vault(r, lvl,load_on_the_fly,up, down, mob_level, room_wall, window, door, secret)
  if r==1 then
    make_euo_style_dungeon(lvl,load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)
  elseif r==2 then
    make_newstyle_dungeon(lvl,load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)
  else
    make_vault(lvl,load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)
  end
end

function add_spawners_and_lights(map,lvl,centres)

  -- add a futuristic light in 1/3 centers and an invis light in 1/3
  for r,c in ipairs(centres) do
    if int_rand(3)>0 then
      i=0x421 -- 'futuristic light'
      if int_rand(3)==0 then i=0x422 end -- starts off
      map:add_item(c[1], c[2], 1, Item(i))
      -- map:set_as_furniture(c[1], c[2])
    end

    add_vault_spawner(map,lvl,c[1],c[2])
  end
end

function add_vault_spawner(map,lvl,x,y)

  m=0x200
  n=1+int_rand(3)
  str=""
  if int_rand(4)==0 then
    m=0x202
    n=1
    str="2"
  end
  if spawner_nearby(map,x,y) then return; end
  map.spawners:add(0, m, 0, lvl, n, 0, x, y, 3, 0, "level_mob_wrapper"..str)
  map:add_feat(x,y,SPAWNER); -- for maped's benefit only
end

function maybe_add_vending_machine(map, lvl)

  if int_rand(2)==0 then
    local x=0
    local y=0
    while true do
      x=int_rand(map:get_max_x())
      y=int_rand(map:get_max_y())
      if map:get_tile(x,y)==20 and map:get_spawner(x,y)==nil then break; end
    end
    map.spawners:add(0, 0x291, 0, lvl, 1, 0, x, y, -1, 0, "vending_machine_init")
    map:add_feat(x,y,SPAWNER) -- for maped's benefit only
  end
end

function load_map_000(lvl, load_on_the_fly)
  if not is_maped() then map_set_item_code(7, 4, lvl, Item(0x421)) end
  local map=get_map_ptr(lvl)
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do
      map:destroy_pile(x, y)
    end
  end
  map:set_tile(7,1,71)
  map:add_item(7,6,1,Item(0x421))
  map:save_map()
  map:save_items()
end
