-- based on http://orteil.dashnet.org/experiments/RoguelikeMapgen.html

-- fix array indexes !!! lua start with 1, not 0

table.indexOf = function( t, object )
  if "table" == type( t ) then
    for i = 1, #t do
      if object == t[i] then
        return i
      end
    end
    return -1
  else
    error("table.indexOf expects table for first argument, " .. type(t) .. " given")
  end
end

-- i1 is start idx, i2 is end idx BUT NOT included - copy of java slice
table.slice=function (values,i1,i2)

  local res = {}
  local n = #values
  -- default values for range
  i1 = i1 or 1
  i2 = i2 or n
  if i2 < 0 then
    i2 = n + i2 + 1
  elseif i2 > n then
    i2 = n
  end
  if i1 < 1 or i1 > n then
    return {}
  end
  local k = 1
  for i = i1,i2-1 do --note
    res[k] = values[i]
    k = k + 1
  end
  return res
end

function GetMap(x,y)
  if (x<0 or x>=w or y<0 or y>=h) then return -1; else return rmap[x+1][y+1][2]; end
end
function SetMap(x,y,tile)
  if (x<0 or x>=w or y<0 or y>=h) then return false; else rmap[x+1][y+1][2]=tile; end
  return true;
end
function GetMapRoom(x,y)
  if (x<0 or x>=w or y<0 or y>=h) then return -1; else return rmap[x+1][y+1][1]; end
end
function SetMapRoom(x,y,id)
  if (x<0 or x>=w or y<0 or y>=h) then return false; else rmap[x+1][y+1][1]=id; end
  return true;
end

function MakeRoom(X,Y,W,H,tile,roomId)
  local pillars=0
  if (math.random()<pillarPercent) then pillars=get_random_element({1,3}) --get_random_element({1,2,3}) -- 2=big,3=sparse
  end

  local watery=false
  if (math.random()<waterPercent) then watery=true end
  X=math.floor(X)
  Y=math.floor(Y)
  W=math.floor(W)
  H=math.floor(H)
  for x=X,X+W-1 do
    for y=Y,Y+H-1 do
      if (GetMap(x,y)>=1) then
        if tile~=nil then SetMap(x,y,tile) else SetMap(x,y,0); end
        SetMapRoom(x,y,roomId)
        table.insert(dug,{x,y})
        tilesDug=tilesDug+1
      end
    end
  end
  for x=X-1,X+W do
    for y=Y,Y+H-1 do
      if (GetMap(x,y)==1) then
        SetMap(x,y,1.1)
        table.insert(walls,{x,y})
        SetMapRoom(x,y,roomId)
      elseif (GetMap(x,y)==1.1) then
        SetMap(x,y,1.2)
        --walls.slice(walls.indexOf({x,y}),1)
      end
    end
  end
  for x=X,X+W-1 do
    for y=Y-1,Y+H do
      if (GetMap(x,y)==1) then
        SetMap(x,y,1.1)
        table.insert(walls,{x,y})
        SetMapRoom(x,y,roomId)
      elseif (GetMap(x,y)==1.1) then
        SetMap(x,y,1.2)
        --walls.slice(walls.indexOf({x,y}),1)
      end
    end
  end
  --corners
  x=X-1
  y=Y-1
  if (GetMap(x,y)==1) then
    SetMap(x,y,1.1)
    --walls.push([x,y])
    SetMapRoom(x,y,roomId)
  end
  x=X+W
  y=Y-1
  if (GetMap(x,y)==1) then
    SetMap(x,y,1.1)
    --walls.push([x,y])
    SetMapRoom(x,y,roomId)
  end
  x=X-1
  y=Y+H
  if (GetMap(x,y)==1) then
    SetMap(x,y,1.1)
    --walls.push([x,y])
    SetMapRoom(x,y,roomId)
  end
  x=X+W
  y=Y+H
  if (GetMap(x,y)==1) then
    SetMap(x,y,1.1)
    --walls.push([x,y])
    SetMapRoom(x,y,roomId)
  end

  local addedCentre=false
  if tile==nil and W!=1 and H!=1 then
    --for x=X+1,X+W-2 -- does a neat room floor border, not needed for eftv
    for x=X,X+W-1
    do
      for y=Y,Y+H-1
      --for y=Y+1,Y+H-2
      do
        SetMap(x,y,0.1)
        if x==math.floor(X+W/2) and y==math.floor(Y+H/2) and not addedCentre then
          table.insert(gRoomCentres,{x,y})
          addedCentre=true
        end
        if (watery and math.random()<0.8) then
          -- dug.slice(dug.indexOf({x,y}),1);
          SetMap(x,y,0.9)
        end
        local pillaring=false
        if (pillars==1 and (x-X)%2==0 and (y-Y)%2==0 and math.random()<0.8) then pillaring=true
        elseif (pillars==2 and (x-X-1)%3<2 and (y-Y-1)%3<2 and math.random()<0.8) then pillaring=true
        elseif (pillars==3 and (x-X)%3==0 and (y-Y)%3==0 and math.random()<0.8) then pillaring=true
        end
        if (pillaring) then
          --dug.slice(dug.indexOf({x,y}),1);
          SetMap(x,y,0.2);
        end
      end
    end
  end
end

function CheckRoom(X,Y,W,H,thisRoomId)
  X=math.floor(X)
  Y=math.floor(Y)
  W=math.floor(W)
  H=math.floor(H)
  for x=X,X+W-1
  do
    for y=Y,Y+H-1
    do
      --if ((GetMap(x,y)~=1))-- and roomId==-1) or (roomId~=-1 and GetMapRoom(x,y)~=roomId))
      --doreturn falseend
      if (GetMap(x,y)~=1 and thisRoomId==-1) then return false; end
      if (GetMapRoom(x,y)~=thisRoomId and thisRoomId~=-1 and GetMap(x,y)~=1) then return false; end
      if (not mirror) then
        if (x<1 or x>=w-1 or y<1 or y>=h-1) then return false; end
      else
        if (x<1 or x>=w/2-1 or y<1 or y>=h/2-1) then return false; end
      end
    end
  end
  return true
end

w=40
h=40

gRoomCentres={}
function Init()

  rmap={}
  for x=0,w-1
  do
    rmap[x+1]={}
    for y=0,h-1
    do
      rmap[x+1][y+1]={-1,1}
      if (x<1 or x>=w-1 or y<1 or y>=h-1) then rmap[x+1][y+1]={-1,1.1}; end
    end
  end

  walls={}
  dug={}
  rooms={}
  gRoomCentres={}
  tilesDug=0
  roomId=0
  mirror=false -- awesome - need to fix ladders though
  -- if (math.random()<0.3) then mirror=true end
  roomSize=15
  corridorSize=5
  percentToFill=0.2
  corridorPercent=0.2
  pillarPercent=0
  waterPercent=0

  roomSize=math.floor(math.random()*15)+10
  corridorSize=math.floor(math.random()*5)+1
  corridorPercent=math.random()*0.7+0.1

  -- pillarPercent=math.random()
  -- percentToFill=0.05+math.random()*0.3
  -- waterPercent=math.random()

  if (mirror) then percentToFill=percentToFill/4; end

  stuck=0
  tooMuchStuck=100
  digs=0
  Dig()
end

function Carve(wall,side,roomId)
  local rx=wall[1]+side[1]
  local ry=wall[2]+side[2]
  local rw=1
  local rh=1
  local expansions={{0,1,2,3}}
  local corridor=0
  if (math.random()<corridorPercent) then corridor=1; end
  if (corridor==1) then expansions={{0,2},{1,3}}; end
  expansions=get_random_element(expansions)
  local steps=roomSize
  if (corridor==1) then steps=corridorSize; end
  for i=1,steps
  do
    if (#expansions==0) then break; end

    local xd=0
    local yd=0
    local wd=0
    local hd=0
    local side=get_random_element(expansions)
    if (side==0) then xd=-1; wd=1
    elseif (side==1) then yd=-1; hd=1
    elseif (side==2) then wd=1
    elseif (side==3) then hd=1;
    end
    if (CheckRoom(rx+xd,ry+yd,rw+wd,rh+hd,roomId)) then rx=rx+xd;ry=ry+yd;rw=rw+wd;rh=rh+hd;
      --else expansions.slice(expansions.indexOf(side),1);
    end
  end
  if (rw>1 or rh>1)
  then
    MakeRoom(rx,ry,rw,rh,nil,roomId)
  end
  if (rw==1 or rh==1) then corridor=1; end -- else corridor=0
  return {x=rx,y=ry,w=rw,h=rh,corridor=corridor}
end

function PickWall(x,y,w,h)

  -- x=x or 0
  if (x)
  then
    local myWalls={}
    for i,wall in pairs(walls)
    do
      if (wall[1]>=x and wall[1]<x+w and wall[2]>=y and wall[2]<y+h) then table.insert(myWalls,wall); end
    end
    return get_random_element(myWalls)
  else
    return get_random_element(walls)
  end
  return false
end

function RandomIn(room)
  local tiles={}
  for x=0,w-1
  do
    for y=0,h-1
    do
      if (GetMapRoom(x,y)==room and GetMap(x,y)<=0.1) then table.insert(tiles,{x,y}); end
    end
  end
  return get_random_element(tiles)
end

function Dig()
  local carvedARoom=0
  if (digs==0)
  then
    --local rw=math.random()*6+2
    --local rh=math.random()*6+2
    --MakeRoom(w/2-rw/2,h/2-rh/2,rw,rh,nil,roomId)
    local rw=math.random()*6+2
    local rh=math.random()*6+2
    MakeRoom(w/2-rw/2,h/2-rh/2,rw,rh,nil,roomId)
    rooms[roomId]={parent=-1,gen=1,corridor=0}
    roomId=roomId+1
    carvedARoom=1
  else
    local wall=PickWall()
    if (not wall) then stuck=stuck+1
    else
      local parentRoom=rooms[GetMapRoom(wall[1],wall[2])]
      local sides={}
      if (GetMap(wall[1]-1,wall[2])==1) then table.insert(sides,{-1,0}); end
      if (GetMap(wall[1]+1,wall[2])==1) then table.insert(sides,{1,0}); end
      if (GetMap(wall[1],wall[2]-1)==1) then table.insert(sides,{0,-1}); end
      if (GetMap(wall[1],wall[2]+1)==1) then table.insert(sides,{0,1}); end
      local side=get_random_element(sides)
      if (not side) then stuck=stuck+1
      else
        local gen=parentRoom.gen+1
        MakeRoom(wall[1],wall[2],1,1,0.5,roomId) --door
        -- walls.slice(walls.indexOf(wall),1)
        local room=Carve(wall,side,roomId)
        thisIsACorridor=room.corridor
        if (math.random()<0.95)--branch
        then
          for i=0,1
          do
            local wall=PickWall(room.x,room.y,room.w,room.h)
            if (wall)
            then
              local sides={}
              --if (GetMap(wall[0]-1,wall[1])==1) then sides.push([-1,0]); end
              --if (GetMap(wall[0]+1,wall[1])==1) then sides.push([1,0]); end
              --if (GetMap(wall[0],wall[1]-1)==1) then sides.push([0,-1]); end
              --if (GetMap(wall[0],wall[1]+1)==1) then sides.push([0,1]); end
              sides={{-1,0},{1,0},{0,-1},{0,1}}
              local side=get_random_element(sides)
              if (side)
              then
                local room=Carve(wall,side,roomId)
                if (room.corridor==0) then thisIsACorridor=0; end
              end
            end
          end
        end
        rooms[roomId]={parent=parentRoom,gen=gen,corridor=thisIsACorridor}
        roomId=roomId+1
        carvedARoom=1
      end
    end
  end

  digs=digs+1

  if (tilesDug<(w*h)*percentToFill and stuck<tooMuchStuck)
  then
    Dig()
  else
    if (mirror)
    then
      for x=0,w/2-1
      do
        for y=0,h/2-1
        do
          rmap[w-x-1+1][y+1]=rmap[x+1][y+1]
          rmap[x+1][h-y-1+1]=rmap[x+1][y+1]
          rmap[w-x-1+1][h-y-1+1]=rmap[x+1][y+1]
        end
      end
    end

    local highest=0
    local highestId=0
    for i,val in pairs(rooms)
    do
      if (rooms[i].gen>highest and rooms[i].corridor==0) then highest=rooms[i].gen; highestId=i; end
    end

    local spot=RandomIn(0)
    SetMap(spot[1],spot[2],0.7)

    local spot=RandomIn(highestId)
    SetMap(spot[1],spot[2],0.6)

    -- Draw()
  end
end

function make_newstyle_dungeon(lvl, load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)
  -- uncomment so map is randomised only on server load!
  if not ok_to_regen_random_lua_map(lvl) then return end

  local map=get_map_ptr(lvl)
  map:set_size(100,100,true)
  map:del_all_spawners()

  -- reset to all dirt
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do

      map:set_tile(x, y, 32)
      map:del_feat(x, y)
      map:destroy_pile(x, y)

    end
  end

  w=map:get_max_x()
  h=map:get_max_y()
  Init()

  for x = 0,w-1 do
    for y = 0,h-1 do
      t=convertTile(rmap[x+1][y+1][2], room_wall, window, door, secret)
      map:set_tile(x,y,t)
    end
  end

  -- map monster lvl goes into 1,1
  map:add_feat(1,1,SIGN,mob_level)

  -- chest spawner
  map.spawners:add(2,mob_level+1,0,lvl,math.random(5,10),0,2,2,0)
  map:add_feat(2,2,SPAWNER); -- for maped's benefit only

  a={70,71,72,73,74,160}
  add_litter_against_walls(map, 20, room_wall, a, 4, 160, 161)

  add_spawners_and_lights(map,lvl,gRoomCentres)

  -- final cleanup
  for x = 0,w-1 do
    for y = 0,h-1 do
      local t=map:get_tile(x,y)
      if t==60 then
        map:del_feat(x, y)
        map:destroy_pile(x, y)
        map:add_feat(x, y, LV_CHANGE, down)
      elseif t==62 then
        map:del_feat(x, y)
        map:destroy_pile(x, y)
        map:add_feat(x, y, LV_CHANGE, up)
      end
    end
  end

  maybe_add_vending_machine(map,lvl)

  map:save_map();
  map:save_features();
  map:save_items();
end

function convertTile(f, room_wall, window, door, secret)
  if f==0 then return 19 -- standard floor
  elseif f==0.1 then return 20 -- roomfloor
  elseif f==0.2 then return 73 -- pillar
  elseif f==0.5 then return door -- door
  elseif f==0.6 then return 60 -- ladder down
  elseif f==0.7 then return 62 -- ladder up
  elseif f==0.9 then return 220 -- water
  elseif f==1 then return 87 -- default wall
  elseif f==1.1 then return room_wall -- edgewall
  elseif f==1.2 then return room_wall -- intersecting
  end
  return 32
end

