function make_euo_style_dungeon(lvl,load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)

  if not ok_to_regen_random_lua_map(lvl) then return end
  local map=get_map_ptr(lvl)
  map:del_all_spawners()
  -- reset to all walls
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do

      t=87 -- default wall
      map:set_tile(x, y, t)
      map:del_feat(x, y)
      map:destroy_pile(x, y)

    end
  end
  local tilespec=string.format("%d,%d,%d,%d,%d",19,87,room_wall,20,secret)

  map:mk_random(lvl, 0, up, down, RT_DUNGEON, tilespec, "", 0)
  map.is_random=false

  -- convert all doors to the right colour
  -- 110->door
  add_litter(map,110,{door},1)

  -- add your own litter
  local a={70,71,72,73,74,160}
  add_litter_against_walls(map, 20, room_wall, a, 6, 160, 161)

  -- add your own spawners
  -- map monster lvl goes into 1,1
  map:add_feat(1,1,SIGN,mob_level)

  -- chest spawner
  map.spawners:add(2,mob_level+1,0,lvl,math.random(5,10),0,2,2,0)
  map:add_feat(2,2,SPAWNER); -- for maped's benefit only

  -- for every brazier, convert to futuristic light and add spawner
  for x=0,map:get_max_x()-1 do
    for y=0,map:get_max_y()-1 do

      itm=map:get_item_code(x,y)
      if itm==Item(0x10e) then
        if int_rand(3)==1 then
          map:set_item_code(x,y,Item(0x422))
        else
          map:set_item_code(x,y,Item(0x421))
        end
        map:unset_furniture(x,y)
        add_vault_spawner(map,lvl,x,y)
      end
    end
  end

  maybe_add_vending_machine(map,lvl)

  lx,ly=find_tile(map,60)
  dx,dy=find_tile(map,62)

  if lx==nil or ly==nil or dx==nil or dy==nil or not good_route(lvl,lx,ly,dx,dy,0) then
    if vars~=nil then force_map_to_regen_by_resetting_time(lvl) end -- force to regen
    make_euo_style_dungeon(lvl,load_on_the_fly, up, down, mob_level, room_wall, window, door, secret)
    writelog2("euo dungeon force regen no route!")
  else
    map:save_map()
    map:save_features()
    map:save_items()
  end
end

