function mob_dies(mob_id, killer_id)
end

function mob_hits(mob_id, target_id)

  local m=get_monster_ptr(mob_id)
  local tgt=get_sent_ptr(target_id)
  if m==nil or tgt==nil then return end

  if m.code==0x202 and int_rand(3)==0 then
    ability_zap("zap",m,tgt,false,tgt.x,tgt.y)
  end

end

function mob_kills(mob_id, target_id)
end

function hit(tgt_id, attacker_id)

  -- if attacker uses cross bow then 50% chance to place bolt on corpse
  -- but does not work for killing blow!
  local m=get_sent_ptr(attacker_id)

  if attacker_id==0 then
    local p=get_player_ptr(attacker_id)
    local ammo=wl:get_ammo_type(p.weapon)
    if wl:is_ranged(p.weapon) and ammo==Item(0x150) and int_rand(100)<50 then
      give_item(tgt_id, ammo)
    end
  end

  local tgt=get_sent_ptr(tgt_id)

  -- evil wild dogs get easily confused (andunconfused) each hit
  if tgt~=nil and tgt.code==0x201 and int_rand(5)==0 and tgt:get_align()==ALIGN_EVIL then
    if tgt:get_health(HN_CONFUSED)==0 then
      tgt:set_health(HN_CONFUSED,3)
    else
      tgt:set_health(HN_CONFUSED,0)
    end
    update_everyones_fov(tgt)
  end

  -- mantis skewers
  if m.code==0x20d and m.ai_misc_int==0 then
    if tgt_id<100 then
      send_message(tgt_id, "You've been skewered and paralysed!")
    end
    set_health(tgt_id, HN_HELD, 4)
    m.ai_misc_int=10
  end
end

function mob_select_spell(id,target_id,spells)

  hp,hpmax,mana,manamax = get_hp_and_mana(id)
  thp,thpmax,tmana,tmanamax = get_hp_and_mana(target_id)
  invis=get_health(id,HN_INVISIBLE)

  num_spells=#spells
  if num_spells==0 then
    return ""
  end

  m=get_sent_ptr(id)

  -- eftv: this makes rad scorpion & robot cast a lot less often
  if (m.code==0x205 or m.code==0x202) and int_rand(4)>0 then return "" end

  tgt=get_sent_ptr(target_id)
  if tgt==nil then return ""; end
  is_adjacent=adjacent(m,tgt)
  -- if adjacent then writelog2("adj") end

  emerg=spells[math.random(num_spells)]
  rand_spells={}
  r_idx=0
  for idx,sp in pairs(spells) do

    if false then
      -- add spells with restrictions here
    elseif sp=="kxq" then
      if int_rand(4)==1 then return sp end
    else
      -- spell has no restrictions, add it to rand list
      r_idx=r_idx+1
      rand_spells[r_idx]=sp
    end

  end

  num_spells=#rand_spells
  if num_spells==0 then
    -- return emerg
    return "" -- cpp AI will now change mind if we dont have a spell to cast
  end
  sp=rand_spells[math.random(num_spells)]
  -- writelog2("END select spell = "..sp)
  return sp

end

function level_mob_wrapper(m)

  local map=get_map_ptr(m.map_level)
  local l=map:get_feat_val(1,1)
  if l<1 then l=1 end
  set_monster_level(m, l)
  set_other_mob_params(m)
end
function level_mob_wrapper2(m)

  local map=get_map_ptr(m.map_level)
  local l=map:get_feat_val(1,1)
  if l<1 then l=1 end
  set_monster_level(m, l)
  set_other_mob_params(m)
end

function set_other_mob_params(m)
  if m.code==0x207 then m.heartbeat_func="apoc_cow_actions" end
  if m.code==0x209 then m.heartbeat_func="reanimated_soldier_actions" end
  if m.code==0x206 then
    m:unlearn_spells()
    local spells={"xmp","ijo","kxq"}
    spells[math.random(1,3)]=nil
    for k,v in pairs(spells) do
      m:learn_spell(v)
    end
  end
  -- mouse: sometimes mutations
  if m.code==0x200 and (int_rand(7)==0 or m.map_level==10) then

    m.mana=100
    local r=int_rand(3)
    if m.map_level==10 and r==0 then r=1 end
    if r==0 then
      m:learn_spell("ip2")
      m.code=0x0f0200
    elseif r==1 then
      m:learn_spell("zap")
      m.code=0x00f200
    else
      m:learn_spell("vf")
      m.code=0xf00200
    end
  end
  -- phase spider
  if m.code==0x204 then
    m.heartbeat_func="phase_spider_actions"
    m:set_health(HN_TRANSPARENT, -1)
  end
  -- terminator
  if m.code==0x208 then
    m.heartbeat_func="terminator_actions"
    m:set_thaco(0)
  end

  -- mutant spawns 2 raiders
  if m.code==0x206 and not is_maped() then
    local m2=spawn_near_id(0x20c,m.id,false)
    level_mob_wrapper(m2)
    m2=spawn_near_id(0x20c,m.id,false)
    level_mob_wrapper(m2)
  end
  if m.code==0x20d then
    m.heartbeat_func="mantis_actions"
  end

  -- scorpions sometimes spawn a mantis
  if m.code==0x205 and int_rand(5)==1 and not is_maped() then
    local m2=spawn_near_id(0x20d,m.id,false)
    level_mob_wrapper(m2)
  end

  -- mantis in subway often spawn a lightning rat
  if m.code==0x20d and m.map_level==10 and int_rand(2)==1 and not is_maped() then
    local m2=spawn_near_id(0x200,m.id,false)
    level_mob_wrapper(m2)
  end
  -- reanim sold spawn terminator
  if m.code==0x209 and int_rand(3)==1 and not is_maped() then
    local m2=spawn_near_id(0x208,m.id,false)
    level_mob_wrapper(m2)
  end

end

function set_good_aligned(m)

  m:set_align(ALIGN_GOOD)
end

-- if called with m==nil then return the quality of spawner loot increase
-- this is a cheese - diff c++ funcs call this in diff ways
function spawnerHeroic(m)

  if m==nil then return int_rand(3)+2; end
  scaleCreature(m, 3, 4);
end

function spawnerEpic(m)

  if m==nil then return int_rand(3)+4; end
  scaleCreature(m, 5, 6);
end

function scaleCreature(m, c, qBump)

  m.hp=m.hp*c
  m:set_hp_max(m.hp)
  m.xp_kill=m.xp_kill*c
  m:set_thaco((m:get_thaco()-10)*c+10)
  m:set_base_ac(m:get_ac()+10*(c-1))
  m:set_intel(m:get_intel()*c)
  m:set_magic_resistance(m:get_magic_resistance()*c)
  m:set_dmg_dice(m:get_dmg_dice()*c/2)

  q=m.treasure/0x10000
  q=q+qBump
  if q>15 then q=15 end
  m.treasure=m.treasure & 0xffff+q*0x10000

  m.tamable=false

end

function largeBossSetup(m)
  m.large=true
  scaleCreature(m, 2, 3)
end

function unusualBossSetup(m)
end

function regularBossSetup(m)
end

function equip_monster_weapons(m)
  if m.code==0x209 then
    m.weapon=Item(0x1d)
  elseif m.code==0x203 then
    m.weapon=Item(0x17)
  end
end

function bathplug_init(m)
  m:set_name("Bathplug")
  m:set_align(ALIGN_GOOD)
end

function apoc_cow_actions(m)
  -- charge
  if m:get_health(HN_HELD)~=0 or m:get_health(HN_HEXED)~=0 then return end
  if m.target_id~=-1 then
    local tgt=get_sent_ptr(m.target_id)
    if tgt==nil then return; end
    --if (tgt.x==m.x or tgt.y==m.y) and distance(m.x, m.y, tgt.x, tgt.y)>=2 then
    if distance(m.x, m.y, tgt.x, tgt.y)>=2 then
      if tgt.id<100 then send_message(tgt.id, "The brahman charges!", false, true); end
      ability_charge("charge",m,tgt,false,tgt.x,tgt.y)
    end
  end
end

function reanimated_soldier_actions(m)

  -- cooldown
  if m.ai_misc_int>0 then
    m.ai_misc_int=m.ai_misc_int-1
    return
  end
  if m:get_health(HN_HELD)~=0 or m:get_health(HN_HEXED)~=0 then return end

  local tgt=get_sent_ptr(m.target_id)
  if tgt==nil then return end
  local map=get_map_ptr(m.map_level)

  -- grenade
  if tgt.map_level==m.map_level and int_rand(5)==1 and dist(m.x,m.y,tgt.x,tgt.y)>=2 and map:can_see_with_LOS(m.x,m.y,tgt.x,tgt.y,4) then
    local m2=spawn_near_id(0x20e, tgt.id)
    m2.ai_misc_int=4 -- grenade time
    m2:set_name("grenade: "..m2.ai_misc_int)
    m2.heartbeat_func="grenade_actions"
    m.ai_misc_int=15 -- cooloff
  end
end

function grenade_actions(m)
  -- cooldown
  if m.ai_misc_int>1 then
    m.ai_misc_int=m.ai_misc_int-1
    m:set_name("grenade: "..m.ai_misc_int)
    make_players_forget_mob_name(m.id)
    update_everyones_fov(m)
    return
  end
  m.time_alive=0
  explosion(m.id, m.x, m.y, m.map_level, 1, 10, 5, true, true)
end

function phase_spider_actions(m)

  if m:get_health(HN_HELD)~=0 or m:get_health(HN_HEXED)~=0 then return end
  if m.target_id~=-1 then

    if int_rand(7)==0 then

      m:set_health(HN_INVISIBLE, 3)
      spell_blink_random("ip2",m,nil,true,m.x,m.y,"")
      m:learn_spell("xmp")
      m.mana=100
    else
      m:set_health(HN_INVISIBLE, 0)
      local ptr=get_sent_ptr(m.target_id)
      -- this makes spider attack melee always
      if ptr~=nil and adjacent(m,ptr) then
        m:unlearn_spells()
        m.mana=0
      end
    end
  end
end

function terminator_actions(m)

  -- cooldown
  if m.ai_misc_int>0 then
    m.ai_misc_int=m.ai_misc_int-1
    return
  end
  if m:get_health(HN_HELD)~=0 or m:get_health(HN_HEXED)~=0 then return end

  local R=6
  if m.target_id~=-1 then
    local ptr=get_sent_ptr(m.target_id)
    if ptr==nil or ptr.map_level~=m.map_level then return end

    local dx=ptr.x-m.x
    local dy=ptr.y-m.y
    local d=distance(m.x,m.y,ptr.x,ptr.y)

    if dx~=0 and dy~=0 and not adjacent(m,ptr) or d>R then
      m:clear_waypoints()
      m:add_waypoint(m.x+dx, m.y+dy)
    end
    local map=get_map_ptr(m.map_level)
    -- attack only when NSE or W
    if (dx==0 or dy==0 or math.abs(dx)==math.abs(dy)) and d<=R and map:can_see_with_LOS(m.x,m.y,ptr.x,ptr.y,R) then
      spell_lightning_bolt_autotarget("terminate",m,ptr,true,ptr.x,ptr.y,"")
      m.ai_misc_int=5
      m:clear_waypoints()
    end
  end
end

function mantis_actions(m)

  -- cooldown
  if m.ai_misc_int>0 then
    m.ai_misc_int=m.ai_misc_int-1
    return
  end
end

function rustavinious_actions(m)

  -- cooldown
  if m.ai_misc_int>0 then
    m.ai_misc_int=m.ai_misc_int-1
    return
  end
  if m:get_health(HN_HELD)~=0 or m:get_health(HN_HEXED)~=0 then return end

  if m.target_id~=-1 then
    local ptr=get_sent_ptr(m.target_id)
    if ptr==nil or ptr.map_level~=m.map_level then return end

    if int_rand(4)==1 then

      local m2=spawn_near_id(0x207,m.id,true) -- terminator cow
      if m2~=nil then
        simple_send_event(m2.id,EVENT_MAGIC,0x17,m2.x,m2.y)
        m.ai_misc_int=10
        m2.heartbeat_func="terminator_actions"
        m2:set_align(ALIGN_EVIL)
        m2.hp=50
        m2.mana=100
        m2:set_intel(500)
        m2:set_hp_max(50)
        update_everyones_fov(m2)
      end
    end
  end
end

-- this is the alignment of ALIGN_CUSTOM mobs
function monster_will_attack(m, p)
  return 0
end

