function use_102 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_heal (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_104 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_mana (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_105 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_cure (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_106 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_invis (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_107 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_combat (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_112 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_nothing (id,tgt_id,alt,itm,bcode,x,y,z)
end
function use_114 (id,tgt_id,alt,itm,bcode,x,y,z)
  effect_strength (id,tgt_id,alt,itm,bcode,x,y,z)
end

function get_known_pill_item_from_colour(colour)
  --writelog2("gkpifc c="..colour)
  local pills={0x114, 0x102, 0x104, 0x105, 0x106, 0x107, 0x112}
  local e=colour
  if is_offline() then
    e=get_player_int_var(0,"pill"..colour)
  end
  return make_code(pills[e+1],colour+0x20,0,0)
end

function knows_pill_colour(colour)
  --writelog2("kpc c="..colour)
  if is_online() then return true; end
  return get_player_int_var(0, "pillknown"..colour)==1
end
function make_unknown_pill_item(colour)
  --writelog2("mupi c="..colour)
  return make_code(0x10d,colour+0x20,0,0)
end
function set_pill_colour_known(colour)
  --writelog2("spck c="..colour)
  set_player_int_var(0,"pillknown"..colour, 1)
  -- need to change item codes in inventory
  change_player_item_code(0, make_unknown_pill_item(colour), get_known_pill_item_from_colour(colour), true, true)
  -- need to update pills across all maps!
  change_item_code_in_maps(make_unknown_pill_item(colour), get_known_pill_item_from_colour(colour))
end

-- the un-id pill
function use_10d (id,tgt_id,alt,itm,bcode,x,y,z)
  local colour=get_material(itm)-0x20
  --writelog2("use10d c="..colour)
  use_pill(colour, id,tgt_id,alt,itm,bcode,x,y,z)
end

function use_pill(colour,id,tgt_id,alt,itm,bcode,x,y,z)

  local e=color
  if is_offline() then e=get_player_int_var(0,"pill"..colour) end

  --writelog2("usepill c="..colour.." e="..e)
  local had_effect
  if e==0 then
    had_effect=effect_strength (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==1 then
    had_effect=effect_heal (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==2 then
    had_effect=effect_mana (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==3 then
    had_effect=effect_cure (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==4 then
    had_effect=effect_invis (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==5 then
    had_effect=effect_combat (id,tgt_id,alt,itm,bcode,x,y,z)
  elseif e==6 then
    had_effect=effect_nothing (id,tgt_id,alt,itm,bcode,x,y,z)
  end
  if had_effect then
    if is_offline() then set_pill_colour_known(colour) end
    send_message(id, "The "..wl:get_full_name(get_known_pill_item_from_colour(colour)).." goes down easily.")
  end
  update_fov(id)
end

-- helper func for pill use
-- not actually called by euo
function use_pill_helper(id, tgt_id, itm)

  -- common checks for pills
  -- eg cursed->halluc, or can't drink when choking
  -- gives empty flask

  -- returns 1 if something went wrong

  local rc=0
  local p=get_player_ptr(id)
  local bc=get_base_code(itm)

  if tgt_id<0 and bc~=0x164 then -- cyan doesnt need target tho it's directional
    send_message(id,"Use pill on what?")
    return 1
  end

  -- choking check only for self drink
  if tgt_id>=0 and id==tgt_id and get_health(tgt_id, HN_CHOKING)~=0 then
    send_message(id, "You can't eat that - you are choking!")
    return 1
  end

  if is_cursed(itm) then
    make_hallucinated(id,50) -- hallucinate the user, regardless of the target
    rc=1
  end

  remove_item(id, itm)
  return rc
end

-- helper func
function healer_helper(id, pot)

  local tgt=get_sent_ptr(id)
  if(tgt==nil) then return 0; end
  if(tgt.hp<1) then return 0; end

  local healed=0

  healed=30+int_rand(21);
  if(healed<tgt:get_hp_max()/5) then healed=tgt:get_hp_max()/5; end -- 20%

  healed=math.floor(healed)

  if(healed<1) then healed=1;end
  if(healed>(tgt:get_hp_max()-tgt.hp)) then healed=tgt:get_hp_max()-tgt.hp; end

  if tgt:get_health(HN_WOUNDED)~=0 then healed=0; end
  if pot~=Item(0x147) and not tgt:is_organic() then healed=0 end -- not spare parts

  return healed
end

-- blah
function effect_heal (id,tgt_id,alt,itm,bcode,x,y,z)

  local p=get_player_ptr(id)
  if use_pill_helper(id, tgt_id, itm)~=0 then return ; end

  local hp,hpmax,mana,manamax = get_hp_and_mana(tgt_id)
  local healed=healer_helper(tgt_id,itm)

  if get_health(tgt_id,HN_WOUNDED)~=0 then healed=0 end
  if healed>0 then
    heal(tgt_id, healed)
    if(is_player(tgt_id)) then
      send_party_info(tgt_id)
      sync_stats(tgt_id)
      if tgt_id~=id then send_message(tgt_id, "Healed "..healed.." HP!") end
    end
    update_fov(tgt_id) -- so bars are updated
    send_message(id, "Healed "..healed.." HP!")
    return true
  else
    send_message(id, "No effect!")
  end
end

function effect_mana (id,tgt_id,alt,itm,bcode,x,y,z)

  local p=get_player_ptr(id)

  if use_pill_helper(id, tgt_id, itm)~=0 then return ; end

  sync_health(id)

  local hp,hpmax,mana,manamax = get_hp_and_mana(tgt_id)

  -- heal to mana
  local healed=manamax-mana;
  healed=math.floor(healed/3+int_rand(healed*2/3))
  if(healed<1) then healed=1 end

  if(healed>(manamax-mana)) then
    healed=manamax-mana
  end

  if healed>0 then
    restore_mana(tgt_id, healed)
    if(is_player(tgt_id)) then
      send_party_info(tgt_id)
      sync_stats(tgt_id)
      if tgt_id~=id then send_message(tgt_id, "Restored "..healed.." mana!") end
    end

    send_message(id, "Restored "..healed.." mana!")
    return true
  else
    send_message(id, "No effect!")
  end
end

function effect_cure (id,tgt_id,alt,itm,bcode,x,y,z) -- red pot

  if use_pill_helper(id, tgt_id, itm)~=0 then return ; end

  if get_health(tgt_id,HN_POISONED)==0 then
    send_message(id, "No effect!")
  else
    set_health(tgt_id,HN_POISONED,0)
    send_message(id,"Cured!");
    if(id~=tgt_id) then send_message(tgt_id,"Cured!"); end
    return true
  end
end

function effect_invis (id,tgt_id,alt,itm,bcode,x,y,z)

  if(id~=tgt_id) then send_message(id,"Use on self only!"); return; end

  if use_pill_helper(id, tgt_id, itm)~=0 then return; end

  local plyr=get_player_ptr(id)
  plyr:extinguish_torch()

  set_health(tgt_id,HN_INVISIBLE,30)
  send_message(id,"You disappear from view!");
  update_everyones_fov(plyr)
  return true
end

function effect_combat (id,tgt_id,alt,itm,bcode,x,y,z)

  if(id~=tgt_id) then send_message(id,"Use on self only!"); return; end

  if use_pill_helper(id, tgt_id, itm)~=0 then return; end
  local plyr=get_player_ptr(id)
  local str="rather"

  if plyr.thaco_bonus<15 and plyr.dmg_bonus<9 then

    plyr.thaco_bonus=plyr.thaco_bonus+5;
    plyr.dmg_bonus=plyr.dmg_bonus+3;

    if plyr.thaco_bonus>15 then plyr.thaco_bonus=15 ; str="only slightly"; end
    if plyr.dmg_bonus>9 then plyr.dmg_bonus=9; str="only slightly"; end

    send_message(id,"Your combat skills feel "..str.." enhanced.");
    sync_stats(id);
    return true
  else
    send_message(id,"No effect!");
  end
end

function effect_nothing (id,tgt_id,alt,itm,bcode,x,y,z)

  if use_pill_helper(id, tgt_id, itm)~=0 then return; end

  send_message(id,"No effect!");
end

function effect_rage (id,tgt_id,alt,itm,bcode,x,y,z)

  if(id~=tgt_id) then send_message(id,"Use on self only!"); return; end
  if use_pill_helper(id, tgt_id, itm)~=0 then return; end

  if get_health(tgt_id,HN_ENRAGED)~=0 then
    send_message(id, "No effect!")
  else
    set_health(tgt_id,HN_ENRAGED,60)
    send_message(tgt_id,"You feel enraged!");
    local plyr=get_player_ptr(id)
    plyr.rage=100;
    sync_all(tgt_id)
    return true
  end
end

function effect_strength (id,tgt_id,alt,itm,bcode,x,y,z)
  -- perm ads +3 to str
  if use_pill_helper(id, tgt_id, itm)~=0 then return ; end
  local plyr=get_player_ptr(id)
  plyr:bump_stats(3+int_rand(2),0,0)
  send_message(tgt_id,"You feel stronger!")
  sync_all(id)
  return true
end
