MAX_WEAPON_BONUS=8
MAX_ARMOUR_BONUS=6
MIN_ITEM_STAT_BONUS=6
MAX_ITEM_STAT_BONUS=32
MIN_VIGOUR_BONUS=4
MAX_VIGOUR_BONUS=14
MAX_MR_BONUS=4
MAX_NV_BONUS=5

function random_material(itm)

  -- ths function does materials - it will 'coat' an item in a material
  -- try and keep rarites down.
  -- assumes is actually something equippable!

  local material=0; -- MAT_ORDINARY
  local item_type=wl:get_type(itm)
  local grade=wl:get_grade(itm)
  local jewelry=wl:is_jewelry(itm)
  local leather=wl:is_leather(itm)
  local armour=wl:is_armour(itm)

  local r=int_rand(80)

  -- diamond, 1%
  -- must be weapon or gloves
  if r==1 and (item_type==ITEM_WEAPON or item_type==ITEM_GLOVES and grade==A_UNARMOURED) then

    material=MAT_DIAMOND

    -- gold 1%, anything except shield
    -- elseif(r==3 and (item_type==ITEM_WEAPON or jewelry or (grade==A_MEDIUM or grade==A_HEAVY))) then
  elseif r==3 and item_type~=ITEM_SHIELD then

    material=MAT_GOLD

    -- glass - 1%, must be melee weapon
  elseif r==4 and item_type==ITEM_WEAPON then

    material=MAT_GLASS

    -- vampyric - 2% must be weapon or gloves
  elseif r>=25 and r<=26 and (item_type==ITEM_WEAPON or item_type==ITEM_GLOVES and grade==A_UNARMOURED) then

    material=MAT_VAMPYRIC

    -- BR 2% - anything
  elseif r>=27 and r<=28 then

    material=MAT_BLACKROCK

    -- toxic 5%, must be wep or gloves
  elseif r>=35 and r<40 and (item_type==ITEM_WEAPON or item_type==ITEM_GLOVES and grade==A_UNARMOURED) then

    material=MAT_TOXIC

    -- steel armour
  elseif r>=40 and r<45 and armour and (grade==A_HEAVY or grade==A_MEDIUM) then

    material=MAT_STEEL

    -- barbed 2%
  elseif r>=47 and r<49 and (item_type==ITEM_WEAPON or item_type==ITEM_GLOVES and grade==A_UNARMOURED) then

    material=MAT_BARBED

    -- boiled/copper 4% - anything
  elseif(r>=50 and r<54) then

    material=MAT_COPPER

    -- studded 3% - leather non weapons
  elseif r>=54 and r<57 and leather and item_type~=ITEM_WEAPON then

    material=MAT_STEEL

  end

  -- crystal armour, for +0 and for +def only
  if material==0 and int_rand(5)==1 and armour and item_type~=ITEM_SHIELD and (get_to_mod(itm)==0 or get_to_mod(itm)==MP_ARMOUR_BONUS) then

    material=MAT_CRYSTAL
  end

  return make_code(get_base_code(itm), material, get_to_mod(itm), get_modifier(itm));
end

function random_enchant(itm, quality)

  if type(itm)=="number" then itm=Item(itm) end
  local item_type=wl:get_type(itm)
  local p=MP_ORDINARY
  local bonus=0

  if quality<0 then quality=0
  end

  if (item_type==ITEM_TORSO or item_type==ITEM_SHIELD) and int_rand(100)<50 or
  (item_type==ITEM_AMULET or item_type==ITEM_RING or item_type==ITEM_BOOTS or item_type==ITEM_TROUSERS or item_type==ITEM_GLOVES or item_type==ITEM_HAT) and int_rand(5)==1 then

    bonus=(MAX_ARMOUR_BONUS*quality)/16.0;
    p=MP_ARMOUR_BONUS;

  elseif item_type==ITEM_WEAPON or item_type==ITEM_GLOVES and wl:get_grade(itm)==A_UNARMOURED and int_rand(100)>=70 or (item_type==ITEM_AMULET or item_type==ITEM_RING) and int_rand(10)==1 then

    if item_type~=ITEM_AMULET and item_type~=ITEM_RING and quality>=8 and int_rand(4)==1 then

      p=MP_ENCHANTED
      bonus=int_rand(5)

    elseif quality>=4 and quality<15 and item_type~=ITEM_RING and (wl:get_weapon_type(itm)==W_MAGE and int_rand(4)==1 or int_rand(10)==1) then

      p=MP_LEECHING
      bonus=(quality-8)/2
      if bonus<0 then bonus=0 end

    else

      bonus=(MAX_WEAPON_BONUS*quality)/16.0
      p=MP_WEAPON_BONUS

    end

  elseif wl:is_wearable(itm) then

    -- pre-eval stat bonus
    -- bit hard to read --;
    bonus=MIN_ITEM_STAT_BONUS+((MAX_ITEM_STAT_BONUS-MIN_ITEM_STAT_BONUS)*quality)/32.0 + 1 + int_rand(((MAX_ITEM_STAT_BONUS-MIN_ITEM_STAT_BONUS)*quality)/32.0);

    local r=int_rand(5)

    if(r==0) then

      p=MP_STR_BONUS

    elseif(r==1) then

      p=MP_INT_BONUS

    elseif(r==2) then

      p=MP_DEX_BONUS

    elseif(r==3) then

      bonus=(MAX_NV_BONUS*quality)/16.0
      p=MP_NIGHTVISION

    elseif(r==5) then

      bonus=(MAX_MR_BONUS*quality)/16.0
      p=MP_MAGIC_RESISTANCE

    end
  end

  if bonus<1 and p~=MP_LEECHING then bonus=1; end -- minumum bonus, except leech which is 0

  local newitm=make_code(get_base_code(itm), 0, p, bonus)
  newitm=random_material(newitm)
  return newitm;
end
