g_save_mapnums={1,15}
g_save_exts={"map","itm","fea"}

-- this gets called first (if required)
function new_player(plyr_id)

  local p=get_player_ptr(plyr_id, false)
  if is_offline() then

    -- marks all random maps as ready to rerandomise
    -- the way the map nums are here is naff ...
    local luamaps={1,2,3,4,8,10,13,15}
    for i,n in ipairs(luamaps) do
      unload_map(n)
      force_map_to_regen_by_resetting_time(n)
    end

    -- delete any old backups
    for i,n in ipairs(g_save_mapnums) do
      for g,ext in ipairs(g_save_exts) do
        fn="smaps/save/"..p.name.."/"..string.format("lvl%03d", n).."."..ext
        writelog2("deleteing backup "..fn)
        os.remove(fn)
      end
    end

    -- randomise pills
    local used_effects={}
    for colour=0,6 do

      local e
      repeat
        e=int_rand(7)
      until not in_array(e, used_effects)
      set_player_int_var(plyr_id, "pill"..colour, e)
      table.insert(used_effects, e)
      set_player_int_var(plyr_id, "pillknown"..colour, 0)
    end
    set_player_int_var(plyr_id, "rustavinious_dead", 0)
    set_player_int_var(plyr_id, "has_bathplug", 0)
  end

  p:set_str(10)
  p:set_dex(10)
  p:set_intel(10)

  -- starting skills and bits and pieces
  local cls=sc:get_classname(p.cls)
  local race=sc:get_racename(p.race)

  if cls=="soldier" then

    p:learn_spell("bash")

  elseif cls=="engineer" then

    p:set_skill(0x14, 20) -- engineering
    p:learn_spell("grenade")

  elseif cls=="televangelist" then

    p:set_skill(0x13, 20) -- televangelism
    p:learn_spell("slow")
  end

  -- starting items here
  p.weapon=Item(0x14)
  p:set_skill(0x3, 20) -- locks

  p.hp=p:get_hp_max()
  if p.mana > p:get_mana_max() then p.mana=p:get_mana_max() end

  -- setting racial feats is done in func above
  -- starting abilities/spells

  p.item_binds[1]=Item(0x21)
  p.item_binds[44]=Item(0x177)

end


-- this gets called 2nd
-- called after plyr loaded - and called after even if a new player!
-- note: connected=false! so give_item does not work
function load_player(plyr_id)

  local p=get_player_ptr(plyr_id, false)

  -- starting skills and bits and pieces
  local cls=sc:get_classname(p.cls)
  local race=sc:get_racename(p.race)

  -- reset
  p.perks[PERK_INFRAVISION]=false
  p.perks[PERK_INORGANIC]=false
  p.perks[PERK_VAMPIRE]=false
  p.perks[PERK_LEECHING_ATTACKS]=false

  p:set_base_sight(1)

  -- racial traits
  if race=="alien" then
    p.perks[PERK_LEECHING_ATTACKS]=true
    p.perks[PERK_INFRAVISION]=true
  elseif race=="mutant" then

  elseif race=="droid" then
    p.perks[PERK_INORGANIC]=true
  end

  -- rest is handled in the races.txt file

  -- restore old map files (only when this player!=map player name)
  -- this doesn't YET backup the other players maps!
  if is_offline() then

    -- backup lvl 1 & 15 of the old player
    for i,n in ipairs(g_save_mapnums) do
      local last_p_name=get_map_owner(n)
      if last_p_name~="" and last_p_name~=p.name then
        writelog2("backing up map "..n.." for "..last_p_name)
        unload_map(n)
        slash=package.config:sub(1,1) -- will be / for linux
        if slash~="/" then slash="\\" end
        os.execute("mkdir smaps" .. slash .. "save" .. slash .. last_p_name)
        for foo, ext in ipairs(g_save_exts) do
          copy_file("smaps/"..string.format("lvl%03d", n).."."..ext, "smaps/save/"..last_p_name.."/"..string.format("lvl%03d", n).."."..ext)
        end
      end
    end

    -- look for backups of my maps
    for i,n in ipairs(g_save_mapnums) do
      local backup_name=get_map_owner(n, p.name) -- chk the saved version
      local curr_name=get_map_owner(n)
      writelog2("lvl "..n..", curr map owner="..curr_name..", backup owner="..backup_name)
      if curr_name~=p.name and backup_name==p.name then
        writelog2("restoring map "..n.." for "..p.name)
        for g,ext in ipairs(g_save_exts) do
          copy_file("smaps/save/"..p.name.."/"..string.format("lvl%03d", n).."."..ext, "smaps/"..string.format("lvl%03d", n).."."..ext)
        end
      end
    end
  end
end

