function get_item_colour_str(itm)

  local str=string.format("%c", 0x10);

  if(is_cursed(itm) and not curse_is_hidden(itm)) then str=string.format("%c", 0x13);
  elseif(is_unidentified(itm)) then str=string.format("%c", 0x14);
  elseif(is_blessed(itm)) then str=string.format("%c", 0x16);
  elseif(wl:is_lesser_artifact(itm)) then str=string.format("%c", 0x09);
  elseif(wl:is_artifact(itm)) then str=string.format("%c", 0x1b);
  elseif(wl:is_named(itm) and get_base_code(itm)<0x100) then str=string.format("%c", 0x1c);
  elseif(is_quest_item(itm)) then str=string.format("%c", 0x12);
  elseif(wl:is_enchanted(itm)) then str=string.format("%c", 0x1d);
  elseif(wl:is_named(itm)) then str=string.format("%c", 0x16);
  end

  return str
end

function size_up(plyr_id, tgt_id)

  local p=get_player_ptr(tgt_id);

  local title=make_title(tgt_id)
  if(p.title~="") then title=p.title; end

  local g="male"
  local lvl=""
  if PLAYER_LEVELS then lvl="level "..p.lvl.." "; end
  if p.gender==70 then g="female"; end
  local n=p.name .. ", ".. lvl .. g.." "..sc:get_racename(p.race)
  if plyr_id==tgt_id then n="yourself" end
  local msg="You see " .. n

  if(title~="") then msg=msg..", "..title; end

  -- add clan full name here
  if(p.clan~="") then
    msg=msg..", member of "..clans:get_full_clan_name(p.name)
  end

  local c
  local cnt=0

  if(p.weapon:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.weapon); send_message(plyr_id, "R-hand: "..c..wl:get_full_name(p.weapon)); cnt=cnt+1; end
  if(p.shield:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.shield); send_message(plyr_id, "L-hand: "..c..wl:get_full_name(p.shield)); cnt=cnt+1; end
  if(p.hat:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.hat); send_message(plyr_id, "Head: "..c..wl:get_full_name(p.hat)); cnt=cnt+1; end
  if(p.armour:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.armour); send_message(plyr_id, "Torso: "..c..wl:get_full_name(p.armour)); cnt=cnt+1; end
  if(p.gloves:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.gloves); send_message(plyr_id, "Hands: "..c..wl:get_full_name(p.gloves)); cnt=cnt+1; end
  if(p.trousers:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.trousers); send_message(plyr_id, "Legs: "..c..wl:get_full_name(p.trousers)); cnt=cnt+1; end
  if(p.belt:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.belt); send_message(plyr_id, "Belt: "..c..wl:get_full_name(p.belt)); cnt=cnt+1; end
  if(p.boots:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.boots); send_message(plyr_id, "Feet: "..c..wl:get_full_name(p.boots)); cnt=cnt+1; end
  if(p.ring1:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.ring1); send_message(plyr_id, "Ring: "..c..wl:get_full_name(p.ring1)); cnt=cnt+1; end
  if(p.ring2:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.ring2); send_message(plyr_id, "Ring: "..c..wl:get_full_name(p.ring2)); cnt=cnt+1; end
  if(p.amulet:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.amulet); send_message(plyr_id, "Neck: "..c..wl:get_full_name(p.amulet)); cnt=cnt+1; end
  if(p.sigil1:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.sigil1); send_message(plyr_id, "Mind Sigil: "..c..wl:get_full_name(p.sigil1)); cnt=cnt+1; end
  if(p.sigil2:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.sigil2); send_message(plyr_id, "Body Sigil: "..c..wl:get_full_name(p.sigil2)); cnt=cnt+1; end
  if(p.sigil3:isValid()) then if(cnt==0) then send_message(plyr_id,msg..", wearing:"); end; c=get_item_colour_str(p.sigil3); send_message(plyr_id, "Spirit Sigil: "..c..wl:get_full_name(p.sigil3)); cnt=cnt+1; end
  if(cnt==0) then send_message(plyr_id,msg); end

end
