-- return 0 if spell considered successful
-- don't need to send fov
-- caster guaranteed to be not nil, but target needs to be checked

function spell_gouge(name,spell_id,caster,target,ench,x,y,parms)

  -- simple attack + blind/confuse target
  if caster.id>=100 then return 1; end
  -- if caster==nil or target==nil) then return 1; end

  local p=get_player_ptr(caster.id)

  local sk=wl:get_wep_skill_name(p.weapon)
  if sk~="melee weapons" then

    send_message(caster.id,"Requires melee weapon equipped in main hand!");
    return 1;
  end

  if target.id<100 then
    send_message(target.id,"You've been stabbed in the face and blinded!");
  end
  target:set_health(HN_BLIND,10)

  local rc, ad
  local dmg=0
  rc,dmg = do_combat(p, target, ATT_NORMAL, dmg, 0, 1.1);
  ad, rc = attack_cleanup(p, target, rc, dmg, ATT_NORMAL, CF_SUPER_SPLAT);
  if no_combat(rc) then
    send_message(caster.id,"Aborted!", false, true)
    return 1
  end
  return 0;

end

function set_ranged_weapon(p)
  if wl:get_weapon_type(p.weapon)~=W_BOWS and wl:get_weapon_type(p.weapon)~=W_GUNS and wl:get_weapon_type(p.weapon)~=W_ENERGY then

    -- try and auto switch
    for i=0,MAX_BINDS-1 do
      local w=p.item_binds[i]
      if wl:get_weapon_type(w)==W_BOWS or wl:get_weapon_type(w)==W_GUNS or wl:get_weapon_type(w)==W_ENERGY then

        if wl:get_ammo_type(w)==0 or get_player_item_qty(p.id, wl:get_ammo_type(w))>0 then
          p.weapon=w
          return false
        end
      end
    end
    send_message(caster.id,"Requires ranged weapon equipped in main hand!");
    return true
  end
  return false
end

function show_missile_delete_ammo(p, rc, defx, defy)
  -- show missles, delete ammo
  if(rc==ATR_MISS or rc==ATR_HIT or rc==ATR_KILL) then

    if(wl:get_weapon_damage_type(p.weapon)==WD_GUN) then
      send_event(p.map_level,-1,p.x,p.y,EVENT_MISSLE,MISSLE_BULLET,defx,defy);
    elseif(wl:get_weapon_damage_type(p.weapon)==WD_ENERGY) then
      send_event(p.map_level,-1,p.x,p.y,EVENT_MISSLE,MISSLE_LASER,defx,defy);
    else
      send_event(p.map_level,-1,p.x,p.y,EVENT_MISSLE,MISSLE_AMMO,defx,defy);
    end
    if p.id<100 and wl:get_ammo_type(p.weapon)~=0 then remove_item(p.id,wl:get_ammo_type(p.weapon),1,true) end
  end
end

function spell_aimed(name,spell_id,caster,target,ench,x,y,parms)

  -- simple double damage attack that inflicts slow
  if caster==nil or target==nil then return 1; end
  if caster.id>=100 then return 1; end

  local p=get_player_ptr(caster.id)
  local weapon=Item(p.weapon) -- make a copy, otherwise is just a pointer

  if set_ranged_weapon(p) then
    return 1
  end

  -- ammo check
  if wl:get_ammo_type(p.weapon)~=0 and get_player_item_qty(p.id, wl:get_ammo_type(p.weapon))<1 then
    send_message(p.id,"Out of ammo!")
    return 1;
  end

  local rc, ad
  local dmg=0
  local defx=0
  local defy=0
  if target~=nil then
    set_health(target.id,HN_SLOWED,10)
    defx=target.x
    defy=target.y
  end
  -- note how args passed by ref or ptr are returned as multiple return vals
  local fx=EVENT_SHOOT
  if wl:get_weapon_type(p.weapon)==W_GUNS then fx=EVENT_GUN end
  if wl:get_weapon_type(p.weapon)==W_ENERGY then fx=EVENT_LASER end
  send_event(p.map_level,-1,p.x,p.y,fx,0,defx,defy) -- sends the shoot sound
  rc,dmg = do_combat(caster, target, ATT_NORMAL, dmg, 0, 1.5);
  ad, rc = attack_cleanup(caster, target, rc, dmg, ATT_NORMAL, CF_SUPER_SPLAT);

  -- show missles, delete ammo
  show_missile_delete_ammo(p, rc, defx, defy)
  p.weapon=weapon -- switch back
  sync_arms(p.id)

  if caster.id<100 and no_combat(rc) then
    send_message(caster.id,"Aborted!", false, true)
    return 1
  end

  return 0;
end

function spell_spray(name,spell_id,caster,target,ench,x,y,parms)

  -- scatter shot type of thing

  if caster.id>=100 then return 1; end

  local p=get_player_ptr(caster.id)
  local weapon=Item(p.weapon)
  if set_ranged_weapon(p) then
    return 1
  end

  -- ammo check
  if wl:get_ammo_type(p.weapon)~=0 and get_player_item_qty(p.id, wl:get_ammo_type(p.weapon))<1 then
    send_message(p.id,"Out of ammo!")
    return 1;
  end

  local rc, ad, tx, ty, a
  local dmg=0
  tx=target.x
  ty=target.y
  a=target:get_align()
  -- note how args passed by ref or ptr are returned as multiple return vals
  local fx=EVENT_SHOOT
  if wl:get_weapon_type(p.weapon)==W_GUNS then fx=EVENT_GUN end
  if wl:get_weapon_type(p.weapon)==W_ENERGY then fx=EVENT_LASER end
  local shotssfx=1
  if fx~=EVENT_GUN then shotssfx=3 end
  for i=1,shotssfx do
    send_event(p.map_level,-1,p.x,p.y,fx,0,tx,ty) -- sends the shoot sound
  end
  rc,dmg = do_combat(p, target, ATT_NORMAL, dmg, 0, 2);
  ad, rc = attack_cleanup(p, target, rc, dmg, ATT_NORMAL, bitwiseOr(CF_SUPER_SPLAT, CF_NO_FOV_UPDATE))
  show_missile_delete_ammo(p, rc, tx, ty)

  if no_combat(rc) then
    send_message(caster.id,"Aborted!", false, true)
    return 1
  end

  if wl:get_ammo_type(p.weapon)~=0 then remove_item(caster.id,wl:get_ammo_type(p.weapon),1,true) end

  -- now look for 3 nearby targs and shoot them
  for i=1,3 do

    if wl:get_ammo_type(p.weapon)~=0 and get_player_item_qty(p.id, wl:get_ammo_type(p.weapon))<1 then break; end -- no more ammo

    local t=find_npc(tx,ty,caster.map_level,MON_MONSTER,a,3)
    if t==-1 then break; end
    target=get_sent_ptr(t)
    if target==nil then break; end
    local defx=target.x
    local defy=target.y
    rc,dmg = do_combat(p, target, ATT_NORMAL, dmg, 0, 1.5);
    ad, rc = attack_cleanup(p, target, rc, dmg, ATT_NORMAL, bitwiseOr(CF_SUPER_SPLAT, CF_NO_FOV_UPDATE));

    show_missile_delete_ammo(p, rc, defx, defy)
  end

  update_everyones_fov(caster)
  p.weapon=weapon
  sync_arms(p.id)
  return 0
end

function spell_slow(name,spell_id,caster,target,ench,x,y,parms)

  if target==nil then return 1; end

  target:set_health(HN_SLOWED, 8+int_rand(8))
  sync_health(target.id)
  send_event(caster.map_level, caster.id, target.x, target.y, EVENT_MAGIC, spell_id)
  update_everyones_fov(target)
  return 0
end

function spell_fireball(name,spell_id,caster,target,ench,x,y,parms)

  if target==nil then return 1; end
  local hpratio=1-target.hp/target:get_hp_max()
  local max_dmg=target:get_hp_max()
  local req_dmg=max_dmg*hpratio*0.8
  if req_dmg<1 then req_dmg=1; end
  local dmg=0
  local rc, ad
  send_event(caster.map_level, caster.id, caster.x, caster.y, EVENT_MISSLE, MISSLE_FIREBALL, target.x, target.y)
  rc, dmg = do_combat(caster, target, ATT_MAGIC|MT_FIRE, dmg, req_dmg)
  ad, rc = attack_cleanup(caster, target, rc, dmg, ATT_MAGIC, 0)
  return 0
end
